#ifndef CLASS_DEFINE
struct afsocket_source_connection
{
  struct log_handler_pipe super;
  struct io_backend *backend;
  int fd;
  struct io_fd *src;
};
extern struct ol_class afsocket_source_connection_class;
#endif /* !CLASS_DEFINE */

#ifndef CLASS_DECLARE
static void do_afsocket_source_connection_mark(struct ol_object *o, 
void (*mark)(struct ol_object *o))
{
  struct afsocket_source_connection *i = (struct afsocket_source_connection *) o;
  mark((struct ol_object *) i->backend);
  mark((struct ol_object *) i->src);
}

struct ol_class afsocket_source_connection_class =
{ STATIC_HEADER,
  &log_handler_pipe_class, "afsocket_source_connection", sizeof(struct afsocket_source_connection),
  do_afsocket_source_connection_mark,
  NULL
};
#endif /* !CLASS_DECLARE */

#ifndef CLASS_DEFINE
struct afsocket_accept_callback
{
  struct fd_listen_callback super;
  struct syslog_conf *cfg;
  struct io_backend *backend;
  struct log_handler *next;
};
extern struct ol_class afsocket_accept_callback_class;
#endif /* !CLASS_DEFINE */

#ifndef CLASS_DECLARE
static void do_afsocket_accept_callback_mark(struct ol_object *o, 
void (*mark)(struct ol_object *o))
{
  struct afsocket_accept_callback *i = (struct afsocket_accept_callback *) o;
  mark((struct ol_object *) i->cfg);
  mark((struct ol_object *) i->backend);
  mark((struct ol_object *) i->next);
}

struct ol_class afsocket_accept_callback_class =
{ STATIC_HEADER,
  &fd_listen_callback_class, "afsocket_accept_callback", sizeof(struct afsocket_accept_callback),
  do_afsocket_accept_callback_mark,
  NULL
};
#endif /* !CLASS_DECLARE */

#ifndef CLASS_DEFINE
struct afunix_source
{
  struct log_source_driver super;
  struct io_backend *backend;
  struct io_fd *src;
  struct listen_fd *listen;
  struct sockaddr_un saddr;
  int proto;
};
extern struct ol_class afunix_source_class;
#endif /* !CLASS_DEFINE */

#ifndef CLASS_DECLARE
static void do_afunix_source_mark(struct ol_object *o, 
void (*mark)(struct ol_object *o))
{
  struct afunix_source *i = (struct afunix_source *) o;
  mark((struct ol_object *) i->backend);
  mark((struct ol_object *) i->src);
  mark((struct ol_object *) i->listen);
}

struct ol_class afunix_source_class =
{ STATIC_HEADER,
  &log_source_driver_class, "afunix_source", sizeof(struct afunix_source),
  do_afunix_source_mark,
  NULL
};
#endif /* !CLASS_DECLARE */

#ifndef CLASS_DEFINE
struct afinet_source
{
  struct log_source_driver super;
  struct io_backend *backend;
  struct io_fd *src;
  struct listen_fd *listen;
  struct sockaddr_in saddr;
  int proto;
};
extern struct ol_class afinet_source_class;
#endif /* !CLASS_DEFINE */

#ifndef CLASS_DECLARE
static void do_afinet_source_mark(struct ol_object *o, 
void (*mark)(struct ol_object *o))
{
  struct afinet_source *i = (struct afinet_source *) o;
  mark((struct ol_object *) i->backend);
  mark((struct ol_object *) i->src);
  mark((struct ol_object *) i->listen);
}

struct ol_class afinet_source_class =
{ STATIC_HEADER,
  &log_source_driver_class, "afinet_source", sizeof(struct afinet_source),
  do_afinet_source_mark,
  NULL
};
#endif /* !CLASS_DECLARE */

#ifndef CLASS_DEFINE
struct afinet_dest
{
  struct log_dest_driver super;
  struct ol_string *name;
  struct io_fd *dest;
  struct sockaddr_in daddr;
  int proto;
  struct io_backend *backend;
};
extern struct ol_class afinet_dest_class;
#endif /* !CLASS_DEFINE */

#ifndef CLASS_DECLARE
static void do_afinet_dest_mark(struct ol_object *o, 
void (*mark)(struct ol_object *o))
{
  struct afinet_dest *i = (struct afinet_dest *) o;
  mark((struct ol_object *) i->dest);
  mark((struct ol_object *) i->backend);
}

static void do_afinet_dest_free(struct ol_object *o)
{
  struct afinet_dest *i = (struct afinet_dest *) o;
  ol_string_free(i->name);
}

struct ol_class afinet_dest_class =
{ STATIC_HEADER,
  &log_dest_driver_class, "afinet_dest", sizeof(struct afinet_dest),
  do_afinet_dest_mark,
  do_afinet_dest_free
};
#endif /* !CLASS_DECLARE */

#ifndef CLASS_DEFINE
struct afunix_dest
{
  struct log_dest_driver super;
  struct ol_string *name;
  struct io_fd *dest;
  struct sockaddr_un daddr;
  int proto;
  struct io_backend *backend;
};
extern struct ol_class afunix_dest_class;
#endif /* !CLASS_DEFINE */

#ifndef CLASS_DECLARE
static void do_afunix_dest_mark(struct ol_object *o, 
void (*mark)(struct ol_object *o))
{
  struct afunix_dest *i = (struct afunix_dest *) o;
  mark((struct ol_object *) i->dest);
  mark((struct ol_object *) i->backend);
}

static void do_afunix_dest_free(struct ol_object *o)
{
  struct afunix_dest *i = (struct afunix_dest *) o;
  ol_string_free(i->name);
}

struct ol_class afunix_dest_class =
{ STATIC_HEADER,
  &log_dest_driver_class, "afunix_dest", sizeof(struct afunix_dest),
  do_afunix_dest_mark,
  do_afunix_dest_free
};
#endif /* !CLASS_DECLARE */

