/***************************************************************************
 *
 * Copyright (c) 1999 BalaBit Computing
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 * Inspired by nsyslog, originally written by Darren Reed.
 *
 * $Id: afsocket.h,v 1.1 1999/04/11 19:42:53 bazsi Exp $
 *
 ***************************************************************************/

#ifndef __AFUNIX_H_INCLUDED
#define __AFUNIX_H_INCLUDED

#include "syslog-ng.h"
#include "io.h"
#include "sources.h"

#define AFUNIX_PROTO_DGRAM	1
#define AFUNIX_PROTO_STREAM	2

#define AFINET_PROTO_DGRAM      3
#define AFINET_PROTO_STREAM     4

struct log_source_driver *make_afunix_source(const char *fname, int proto, struct io_backend *backend);
struct log_source_driver *make_afinet_source(struct in_addr in, unsigned short port, int proto, struct io_backend *backend);
struct log_dest_driver *make_afinet_dest(struct in_addr dst, unsigned short port, int proto, struct io_backend *backend);
struct log_dest_driver *make_afunix_dest(const char *name, int proto, struct io_backend *backend);

#endif

